// These are duplicated in preferenceDialog.js. Change here -> change there, too.
var showOwnTagsKey = 'delicious.showOwnTags';
var showPopRecTagsKey = 'delicious.showPopRecTags';

var tagLine;
var previousTags;
var allTags;

/**
 * Called when the "post link" dialog box is created. This retrieves the
 * default values for the form parameters from the URL that specifies the
 * box itself. See for example postCurrentPage() in deliciousOverlay.js.
 */
function loadArgs()
{
    cancelService = new CancelService(document.getElementById("postsDialog"));

    var args=window.arguments[0];

    var url = "";
    var description = "";
    var extended = "";
    var tags = "";
    var pair;   
    var isPrivate = false;

    if (args['url'] != null) url=decodeURIComponent(args['url']);
    if (args['description'] != null) description=decodeURIComponent(args['description']);
    if (args['extended'] != null) extended=decodeURIComponent(args['extended']);
    if (args['tags'] != null) tags=decodeURIComponent(args['tags']);
    if (args['isPrivate'] != null) isPrivate=decodeURIComponent(args['isPrivate']);
    if (args['globals'] == null) {
        alert("Del.icio.us extension internal error: globals missing");
        return;
    }
    globals = args['globals'];
    tagLine = new TagLine();
    allTags = new AllTags(globals.userManager.getDefaultUser().tags.getTagNamesSortedByFrequency(), [], tagLine);
    
    if (globals.deliciousService.getUsername().length == 0 || globals.deliciousService.getPassword().length == 0) {
        alert("Please set up an account using the Del.icio.us extension's options first.");
        window.close();
        return;
    }
      
    document.getElementById("url").value = url;
    document.getElementById("description").value = description;
    document.getElementById("extended").value = extended;
    document.getElementById("tags").value = tags;
    document.getElementById("isPrivate").checked = isPrivate;

    var wordsInExtended = extended.replace(/\s+/g, ' ').replace(/^\W+|\W+$/g, '').split(' ').length;
    document.getElementById("extended-row").setAttribute("flex", wordsInExtended/2);

    document.getElementById('extended').focus();
    
    var users = globals.userManager.getUsers();
    var defaultUser = globals.userManager.getDefaultUser().getUsername();
    var postAsPopup = document.getElementById('use-account-popup');
    for (i in users) {
        var item = document.createElement("menuitem");
        item.setAttribute('label', users[i].getAccountName());
        item.setAttribute('value', users[i].getUsername());
        var node = postAsPopup.appendChild(item);
        if (users[i].getUsername() == defaultUser) {
            document.getElementById('use-account-list').selectedItem = item;
        }
    }

	extendedModified();  
  if (nsPreferences.getBoolPref(showOwnTagsKey, true) == true) {
      var tags = globals.userManager.getDefaultUser().tags;
      var errorMsg = tags.gettingTagsFailed ? "Failed to get tags from del.icio.us server" : "You have no tags defined.";
      displayTags(globals.userManager.getDefaultUser().tags.getTagNamesSorted(), "tags-your", errorMsg, "tags-your-row", []);      
	} else {
	    hideElement("tags-your-row");
	}
  if (nsPreferences.getBoolPref(showPopRecTagsKey, true) == true) {
      var text = "Loading tags from del.icio.us.";
      showStatusText("tags-recommended", text);
      showStatusText("tags-popular", text);
      loadExperimentalFields(url, description);
	} else {
      hideElement("tags-recommended-row");
      hideElement("tags-popular-row");
	}
	
	presetFields(url);		
}

function hideElement(id) {
    document.getElementById(id).hidden = true;
}

// Globals, needed to retain some info through the asynchronous loading process.
var g_url = '';
var g_username = '';
var g_password = '';
var g_description = '';
var gExperimentalLoaded = false;
var gRecommendedTags = [];
var gPopularTags = [];

// Globals from the caller. Needs to contain deliciousService and userManager objects.
var globals;

/*
 * Load del.icio.us' experimental post page, parse tags from it and populate
 * the dialog's "experimental" field with them.
 */
function loadExperimentalFields(url, description)
{
    if (gExperimentalLoaded == true) return;
    
   	g_username = globals.deliciousService.getUsername();
    g_password = globals.deliciousService.getPassword();
   	if (g_username.length == 0 || g_password.length == 0) {
   	    window.close();
   	    return;
   	}
    g_url = url;
    g_description = description;
    
	var queryURL = "http://del.icio.us/new/" + encodeURIComponent(g_username) +
		"?v=2&url=" + encodeURIComponent(g_url) +
		"&title=" + encodeURIComponent(g_description);
    globals.cookies.turnCookiesOn();
    asyncGetURL(queryURL, g_username, g_password, false, experimentalAsyncGetURLRequester);
}

/**
 * Tries to load the bookmark with given url. 
 * If it is found the fields are preset.
 */
function presetFields(url) {
		var bookmarkDtlsAsText = globals.deliciousService.getBookmarkByURL(url);		
		
		alert(bookmarkDtlsAsText);
		
		var xmlDOM = new DOMParser().parseFromString(bookmarkDtlsAsText, "text/xml");
		var nsResolver = xmlDOM.createNSResolver( xmlDOM.ownerDocument == null ? xmlDOM.documentElement : xmlDOM.ownerDocument.documentElement);
		var posts = xmlDOM.evaluate("//post", xmlDOM, null, window.XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
		
		if (posts != null && posts.snapshotLength > 0) {
			var moreThanOnePost = posts.snapshotLength > 1; // TODO I have no clue what should be done in that case!
			
			var tags = posts.snapshotItem(0).getAttribute("tag");
			
			document.getElementById("tags").value = tags;
			
			var tagArray = tags.split(" ");
			for (var i = 0; i < tagArray.length; i++) {
				tagClicked(tagArray[i], "tags-your");
			}
			
			var description = posts.snapshotItem(0).getAttribute("extended");
			document.getElementById("extended").value = description;
			extendedModified();
		}
		
}

//
// Callback for the asynchronous getting of user's tags.
//
var experimentalAsyncGetURLRequester = {
    // Process the asynchronous getting of the experimental fields info.
    asyncGetURLResponse: function(resp) {
        globals.cookies.restoreCookieState();
        if (resp != null) {
            gExperimentalLoaded = true;
            var recTags = parseTagsFromResponse(resp, /var\s+tagRec\s*=\s*\[\s*(".*"|\s*,\s*)*\s*]/i);
            displayTags(recTags, "tags-recommended", "No recommended tags found.", "tags-recommended-row", recTags);
            gRecommendedTags = recTags;
            var popTags = parseTagsFromResponse(resp, /var\s+tagPop\s*=\s*\[\s*(".*"|\s*,\s*)*\s*]/i);
            displayTags(popTags, "tags-popular", "No popular tags found.", "tags-popular-row", popTags);
            gPopularTags = popTags;
            allTags.setOtherTags(recTags.concat(popTags));
        }
    },

    // Process error.
    asyncGetURLError: function(error) {
        globals.cookies.restoreCookieState();
        return;
    }
};

//
// Parse tags from the experimental response.
//
function parseTagsFromResponse(resp, regexp)
{
    var tagmatch = resp.match(regexp);
    var tags = [];
    if (tagmatch && tagmatch[1] != null) {
        var tagarray = tagmatch[1].replace(/"/g, '')
        tags = tagarray.split(/\s*,\s*/);
    }
    return tags;
}

//
// Display tags or give a note if none are found. Emphasize given tags.
//
function displayTags(tags, elementId, noneFoundMessage, rowId, tagsToEmphasize)
{
    if (tags.length == 0) {
        showStatusText(elementId, noneFoundMessage);
    } else {
        writeTagsToDialogElement(tags, elementId);
        styleElementTags('tags-your', tagArrayToObject(tagsToEmphasize), function(e){e.style.color = 'red;'});
        document.getElementById(rowId).setAttribute("flex", tags.length);
    }
}

//
// Indicate an error in loading the experimental fields.
//
function showExperimentalError(explanation, exception)
{
    var r = document.getElementById("tags-recommended");
    r.value = explanation + exception;
    r = document.getElementById("tags-popular");
    r.value = explanation + exception;
}    

//
// Write a status text into a tag field.
//
function showStatusText(elementId, aText)
{
    clearLabelsFromElement(elementId);
    var label = document.createElement("label");
    label.setAttribute("value", aText);
    label.setAttribute("style", "font-style: italic;");
    document.getElementById(elementId).appendChild(label);
}

//
// Clear any existing tags or text (labels) from a tag field.
//
function clearLabelsFromElement(elementId)
{
    var element = document.getElementById(elementId);
    var labels = element.getElementsByTagName('label');
    for (var i = labels.length - 1; i >= 0; --i) {
        element.removeChild(labels.item(i));
    }
}

/**
 * Store tags to a XULElement.
 */
function writeTagsToDialogElement(tags, elementId)
{
    clearLabelsFromElement(elementId);
    var element = document.getElementById(elementId);
    for (i in tags) {
        var label = document.createElement("label");
        label.setAttribute("value", tags[i]);
        label.setAttribute("onclick", "tagClicked(this.value,'"+elementId+"');");
        element.appendChild(label);
    }
}

/**
 * Set style for given tags in the given element's tag list.
 */
function styleElementTags(aElementId, aTags, aStyleSetter, aStyleClearer)
{
    var nodelist = document.getElementById(aElementId).childNodes;
    for (var j = nodelist.length - 1; j >= 0; j--) {
        var node = nodelist.item(j);
        if (node.getAttribute('value') in aTags) {
            aStyleSetter(node);
        } else if(aStyleClearer) {
            aStyleClearer(node);
        }
    }
}

/**
 * Tag clicked on the UI.
 */
function tagClicked(tag, elementId)
{
  if (tagLine.changedWord().length > 0 && tag.indexOf(tagLine.changedWord()) == 0) {
    tagLine.completeCurrent(tag);
  } else {
    tagLine.switchTag(tag);
  }
  updateTagLine();
}

/**
 * Change the account to post to a different one.
 */
function changeAccount(event)
{
    clearLabelsFromElement("tags-your");
    globals.userManager.setDefaultUser(event.target.value);
    if (nsPreferences.getBoolPref(globals.deliciousService.showOwnTagsKey, true) == true) {
      displayTags(globals.userManager.getDefaultUser().tags.getTagNamesSorted(), "tags-your", "You have no tags defined.", "tags-your-row", allTags.getOtherTags());
      var tags = tagArrayToObject(document.getElementById("tags").value.split(" "));
      styleElementTags("tags-your", tags, setTagElementSelected, setTagElementUnselected);
      allTags.setUserTags(globals.userManager.getDefaultUser().tags.getTagNamesSortedByFrequency());
    }
}

/**
 * Executed when user confirms the "post link" dialog box.
 */
function accept()
{
    var url = document.getElementById("url").value;
    var description = document.getElementById("description").value;
    var extended = document.getElementById("extended").value;
    var tags = document.getElementById("tags").value;
    var date = new Date();
    var isPrivate = document.getElementById("isPrivate").checked;   

    globals.deliciousService.postURL(url, description, extended, tags, date.toISO8601String(), isPrivate, acceptAsyncGetURLRequester);
    document.documentElement.getButton("accept").disabled = true;
    document.getElementById("status-row").hidden = false;
    document.getElementById("status-text").value = "Posting data."

    tags = tags.match(/\s*(\S.*\S)\s*/);
    if (tags != null) {
        var userTags = globals.userManager.getDefaultUser().tags;
        userTags.addTags(tags[1].split(/\s+/));
        var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
        observerService.notifyObservers(null,"ext:delicious:tagxmlForDefaultUser", userTags.asXml(true));
    }

    return false;
}

/**
 * Executed when the user cancels the post dialog.
 */
function cancelled()
{
    globals.cookies.restoreCookieState();
    return true;
}

//TODO Figure out why this is needed. Firefox 1.5's implementation of dialog.cancelDialog() doesn't close the
//dialog properly (an input field in the dialog needs to be clicked for the browser to realize the window has
//been told to close). So, we set a timer and close the dialog from the timer handler, which seems to work. HACK.
function CancelService(aDlg) {
  var dialog = aDlg;
  var mMessagingTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
  this.doCancel = function() {
    mMessagingTimer.initWithCallback(this, 100, Components.interfaces.nsITimer.TYPE_ONE_SHOT);
  };

 this.notify = function(aTimer) {
    dialog.cancelDialog();
  };
}
var cancelService;

var acceptAsyncGetURLRequester = {
    // Executed when the URL has been posted.
    asyncGetURLResponse: function(resp)
    {
        if (resp != null) {
            cancelService.doCancel();
        } else {
            this.logError();
        }
    },

    // Process error.
    asyncGetURLError: function(error) {
        this.logError();
        return;
    },

    logError: function() {
        document.documentElement.getButton("accept").disabled = false;
        var date = new Date();
        document.getElementById("status-text").value = "Posting failed ("+date.toISO8601String()+"). Click ok to retry or cancel to exit.";
    }
};

/**
 * Add a bunch of tags (for Swap All buttons). Called from XUL.
 */
function addAllTags(tagSet)
{
    var tags = tagSet == "recommended" ? gRecommendedTags : gPopularTags;
    for (t in tags) {
      tagLine.switchTag(tags[t]);
    }
    updateTagLine();
}

/**
 * Format a date as required to make a del.icio.us post (the &dt= parameter).
 * This uses ISO 8601 format: "CCYY-MM-DDThh:mm:ssZ"
 * See here for details: http://www.cl.cam.ac.uk/~mgk25/iso-time.html
 * Example: 1984-09-01T14:21:31Z
 */
Date.prototype.toISO8601String = function()
{
    var str;
    
    // date
    var year = this.getUTCFullYear().toString();
    var month = (this.getUTCMonth()+1).toString();
    month = month.length < 2 ? ("0" + month) :  month;
    
    var day = this.getUTCDate().toString();
    day = day.length < 2 ? ("0" + day) : day;
    
    var hours = this.getUTCHours().toString();
    hours = hours.length < 2 ? ("0" + hours) : hours;
    
    var minutes = this.getUTCMinutes().toString();
    minutes = minutes.length < 2 ? ("0" + minutes) : minutes;
    
    var seconds = this.getUTCSeconds().toString();
    seconds = seconds.length < 2 ? ("0" + seconds) : seconds;
    
    return year + "-" + month + "-" + day + "T" + hours + ":" + minutes + ":" + seconds + "Z";
}

/**
 * Parse an ISO 8601 formatted string into a Date object.
 */
Date.prototype.fromISO8601String = function(str)
{
    str = str.replace("Z","");
    var parts = str.split("T");
    var dateArr = parts[0].split("-");
    var timeArr = parts[1].split(":");
    
    this.setUTCFullYear(dateArr[0]);
    this.setUTCMonth(dateArr[1]-1);
    this.setUTCDate(dateArr[2]);
    this.setUTCHours(timeArr[0]);
    this.setUTCMinutes(timeArr[1]);
    this.setUTCSeconds(timeArr[2]);
}

/**
 * Update extended field's length info when the field is changed.
 */
function extendedModified()
{
    var length = getEncodedLength(document.getElementById("extended").value);
    document.getElementById("extended-label").value = length + " / 255";
}

/**
 * Get encoded byte count
 */
function getEncodedLength(text)
{
    var count = 0;
    for (var i=0; i<text.length; i++) {
        count += Math.ceil(encodeURIComponent(text.charAt(i)).length / 3);
    }
    return count;
}

function tagArrayToObject(aArray)
{
    var tags = {};
    for (t in aArray) {
        tags[aArray[t]] = true;
    }
    return tags;
}

function setTagElementUnselected(e) {e.style.background = 'transparent;'}
function setTagElementSelected(e) {e.style.background = '#ffbbbb;'}

/**
 * Tag field modified, set coloring accordingly. Called from XUL.
 */
function tagsModified(event)
{
    var tags = tagArrayToObject(stripTagString(document.getElementById("tags").value).split(" "));
    styleElementTags("tags-your", tags, setTagElementSelected, setTagElementUnselected);
    styleElementTags("tags-popular", tags, setTagElementSelected, setTagElementUnselected);
    styleElementTags("tags-recommended", tags, setTagElementSelected, setTagElementUnselected);
}

function TagLine()
{
  var currentTags = previousTags = [];  // Arrays of tags: current and previous (before last edits of the tag line).
  var currentLine = "";  // The current tag line as string.
  var currentTagDict = {};  // Current tags as a "dictionary".
  var currentIndex = -1;  // Index of the tag that's been edited (in currentTags).
  var changedWord = '';  // The word that's been changed.
  
  // aClearHistory: true - clears history so that changedWord will not return a word.
  this.update = function(aNewLine, aClearHistory) {
    if (!aClearHistory && aNewLine == currentLine) {
      return;  // If nothing has changed, don't process any further. Otherwise the actual changed word is lost.
    }
    currentLine = aNewLine;
    previousTags = currentTags;
    currentTags = aNewLine.replace(/^\s+/,'').replace(/\s+$/,'').split(/\s+/);
    currentTagDict = tagArrayToObject(currentTags);
    if (aClearHistory) {
      previousTags = currentTags;
      changedWord = "";
    } else {
      changedWord = findChangedWord();
    }
  };
  var findChangedWord = function() {
    var old = previousTags;
    var current = currentTags;
    var pastedCandidate = '';
    currentIndex = -1;
    if (current.length > 0 && (current.length == old.length || current.length == old.length + 1)) {
      for (ic = io = 0; ic < current.length; ic++,io++) {
        if (old[io] != current[ic]) {
          if (pastedCandidate != '') {
            currentIndex = -1
            return '';
          }
          if (old.length > io && old[io+1] == current[ic]) {
            currentIndex = -1
            return '';
          } else {
            if (current.length == old.length + 1 && current[ic].length > 1) {
              pastedCandidate = current[ic];
              currentIndex = ic;
              io++;
            } else {
              currentIndex = ic;
              return current[ic];
            }
          }
        }
      }
    }
    return pastedCandidate;
  };
  this.changedWord = function() {
    return changedWord;
  };
  this.completeCurrent = function(aNew) {
    if (currentIndex == -1) {
      return;
    }
    currentTags[currentIndex] = aNew;
    previousTags = currentTags;
    currentLine = currentTags.join(" ");
    currentTagDict = tagArrayToObject(currentTags);
    currentIndex = -1;
  };
  this.currentTagsAsString = function() {
    return currentTags.join(" ");
  };
  this.taggedAlready = function(aWord) {
    return aWord in currentTagDict;
  };
  this.switchTag = function(aTag) {
    var handled = false;
		
    var cl = currentLine + " ";
    
    // replace regex special characters in the tag
    var aTagForRegEx = aTag.replace("*", "\\*");
    
    var first = cl.match(new RegExp("^"+aTagForRegEx+"\\s+"));
    // Can't simply match to word boundary because tags can include "word-boundarish" characters.
    var inRest = cl.match(new RegExp("\\s"+aTagForRegEx+"\\s+", "g"));		

    if ((first && !inRest) || (!first && inRest)) {
      if (first) {
        this.update(cl.replace(new RegExp("^"+aTag), ""), true);
      } else {
        this.update(cl.replace(new RegExp("\\s"+aTag+"\\s+"), " "), true);
      }
    } else {
      this.update(currentLine + " " + aTag, true);
    }
  };
}

function AllTags(aUserTags, aOtherTags, aTagLine)
{
  var tagLine = aTagLine;
  var otherTags = [];
  var allTags = '';
  var userTags = aUserTags;
  this.processAllTags = function() {
    allTags = '';
    var tmpTags = tagArrayToObject(userTags.concat(otherTags));
    for (t in tmpTags) {
      allTags += t + ' ';
    }
  };
  this.findSuggestions = function() {
    fragment = tagLine.changedWord();
    if (!RegExp(/\S/).test(fragment)) {
      return [];
    }
    var suggestions = [];
    var first = allTags.match(new RegExp("^"+fragment+"\\S*"));
    if (first && !tagLine.taggedAlready(first)) {
      suggestions.push(first);
    }
    // Can't simply match to word boundary because tags can include "word-boundarish" characters.
    var rest = allTags.match(new RegExp("\\s"+fragment+"\\S*", "g"));
    if (rest) {
      for (var i = 0; i < rest.length; i++) {
        var candidate = rest[i].replace(/^\s/,'');
        if (!tagLine.taggedAlready(candidate)) {
          suggestions.push(candidate);
        }
      }
    }
    return suggestions;
  };
  this.setOtherTags = function(aOtherTags) {
    otherTags = aOtherTags;
    this.processAllTags();
  };
  this.setUserTags = function(aUserTags) {
    userTags = aUserTags;
    this.processAllTags();
  };
  this.getOtherTags = function() {
    return otherTags;
  };
  this.setOtherTags(aOtherTags);
}

function stripTagString(aStr)
{
  return aStr.replace(/\s+/g, ' ').replace(/^\s|\s$/g,'');
}

var gPrevTagString = "";
/**
 * Key pressed in tag area. Check if it's a tab and complete the tag if it is.
 */
function tagsOnKeyPress(event)
{
  if (event.keyCode == event.DOM_VK_TAB) {
    event.preventDefault();
  }
}

/**
 * Key released in tag area. Check if suggestions should be updated.
 */
function tagsOnKeyUp(event)
{
  switch (event.keyCode) {
    case event.DOM_VK_SPACE:
      tagLine.update(document.getElementById("tags").value, true);
      break;
    case event.DOM_VK_END:
    case event.DOM_VK_HOME:
    case event.DOM_VK_LEFT:
    case event.DOM_VK_RIGHT:
      clearLabelsFromElement("tags-suggestions");
      break;
    case event.DOM_VK_TAB:
      var suggestions = allTags.findSuggestions();
      if (suggestions.length > 0) {
        tagLine.completeCurrent(suggestions[0]);
        updateTagLine();
      }
      break;
    default:
      tagLine.update(document.getElementById("tags").value);
      var suggestions = allTags.findSuggestions();
      if (suggestions.length > 0) {
        writeTagsToDialogElement(suggestions, "tags-suggestions");
        setTagElementSelected(document.getElementById("tags-suggestions").getElementsByTagName('label').item(0));
      } else {
        clearLabelsFromElement("tags-suggestions");
      }
      break;
  }
}

function updateTagLine()
{
  clearLabelsFromElement("tags-suggestions");
  var tagString = tagLine.currentTagsAsString();
  document.getElementById("tags").value = tagString + (tagString[tagString.length-1] == ' ' ? '' : ' ');
  tagsModified();
}
